### Function

# EBook book_utils_get_recipient_certificates_sync

since: 3.30

#### Declaration [src]

    gboolean
    e_book_utils_get_recipient_certificates_sync (
      ESourceRegistry* registry,
      const GSList* only_clients,
      guint32 flags,
      const GPtrArray* recipients,
      GSList** out_certificates,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Synchronously searches for `recipients` S/MIME or PGP certificates either in provided `only_clients` `EBookClient`, or, when `NULL`, in each found address book configured for auto-completion.

This function can be used within `camel_session_get_recipient_certificates_sync()` implementation.

Available since: 3.30

#### Parameters

`registry`

  Type: `ESourceRegistry`

  An `ESourceRegistry`.

  The data is owned by the caller of the function.

`only_clients`

  Type: A list of `EBookClient*`

  Optional `GSList` of the `EBookClient` objects to search for the certificates in, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`flags`

  Type: `CamelRecipientCertificateFlags`

  Bit-or of `CamelRecipientCertificateFlags`.

`recipients`

  Type: An array of `utf8`

  A `GPtrArray` of recipients’ email addresses.

  The data is owned by the caller of the function.
  Each element is a NUL terminated UTF-8 string.

`out_certificates`

  Type: A list of `utf8`

  A `GSList` of gathered certificates encoded in base64.

  The argument will be set by the function.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.
  Each element is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` when no fatal error occurred, `FALSE` otherwise.